' Lawson Labs, Inc.
' 3239 Phoenixville Pike
' Malvern, PA 19355
' phone 800 321-5355 or 610 725-8800
' FAX   610 725-9344
' email    lawsnlab@netaxs.com
' web page  www.lawsonlabs.com


'   Model 220 24-Channel High Level Digital Input Board

'  Specifications:

'  24 individually isolated digital inputs
'  input voltage is 90 to 250 VAC or 50 to 125 VDC
'  inputs protected against transients up to 500 volts
'  isolation minimum is 1000 volts
'  Output is 5 volt logic, TTL or CMOS compatible
'  Control is via three address lines to select one of eight
'   groups of three bits.
'  Power is 5 VDC at 10 MA, separate 2-pin connector provided

'  The routine below constructs three 8-bit words from the inputs.

' Basic routine to read digital inputs from Model 220 via an LPT port:


  DIM D%(24)                     'array to store digital inputs
  GRP1% = 64: GRP2% = 32: GRP3% = 16   'digital input word groups

' Change the line below to match the addresses for your LPT port
 
  PWA% = &H378: PRA% = &H379     ' parallel port addresses
' PWA% = &H278: PRA% = &H279     ' other possibilities are 278 & 279
' PWA% = &H3BC: PRA% = &H3BD     '  and 3BC & 3BD

  CLS
STARTHERE:
  GOSUB READDIGITAL
  FOR DI% = 1 TO 24
    LOCATE DI%, 1
    PRINT DI%, D%(DI%);           '1 = ACTIVE    0 = INACTIVE
  NEXT
  IF INKEY$ <> "" THEN END ELSE GOTO STARTHERE

'procedure to read digital inputs into D% array
READDIGITAL:
  FOR DIGIN% = 0 TO 7                'loop through 8 bits
    OUT PWA%, DIGIN%                 'building three words each time
                                    
                                     'it may be necessary to insert a
                                     'short pause here for fast systems
    X% = INP(PRA%)
    IF (X% AND GRP1%) THEN D%(DIGIN% + 1) = 1 ELSE D%(DIGIN% + 1) = 0
    IF (X% AND GRP2%) THEN D%(DIGIN% + 9) = 0 ELSE D%(DIGIN% + 9) = 1
    IF (X% AND GRP3%) THEN D%(DIGIN% + 17) = 0 ELSE D%(DIGIN% + 17) = 1
  NEXT DIGIN%
RETURN


'DB 25 Pinout:       use extension cable to LPT port
 
'  1    no connection               13   no connection
'  2    select A                    14   no connection
'  3    select B                    15   no connection
'  4    select C                    16   no connection
'  5    no connection               17   no connection
'  6    no connection               18   no connection
'  7    no connection               19   no connection
'  8    no connection               20   ground
'  9    no connection               21   ground
' 10    group 1 out                 22   ground
' 11    no connection               23   ground
' 12    group 2 out                 24   ground
' 13    group 3 out


' Notes:

'   The power connector and DB25 connector are left off the board
'   when used with the MB1 embedded system. All connections are made
'   via an 8-contact RJ-style connector.

'   Lower input voltages can be accommodated. Contact factory for details.

